import { CompanyActionTypes } from './company.action.types';
import { Action } from '@ngrx/store';
import { Company } from 'src/app/shared/models/company/company.model';
/** all actions related to company */

//get all companies
export class GetAllCompaniesAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES;
  constructor(public payload: any) {}
}

export class GetAllCompaniesActionSuccess implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES_SUCCESS;
  constructor(public payload: Company[]) {}
}

export class GetAllCompaniesActionError implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES_ERROR;
  constructor(public payload: string) {}
}

//create form to create campany

//create form to update company
export class CreateFormToUpdateCompanyAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.CREATE_COMPANY_FORM_UPDATE;
  constructor(public payload: Company) {}
}

export class CreateFormToUpdateCompanyActionSuccess implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.CREATE_COMPANY_FORM_UPDATE_SUCCESS;
  constructor(public payload: Company) {}
}

export class CreateFormToUpdateCompanyActionError implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.CREATE_COMPANY_FORM_UPDATE_ERROR;
  constructor(public payload: string) {}
}

//save form data to update company
export class UpdateCompanyWithFormDataAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.UPDATE_COMPANY_WITH_FORM_DATA;
  constructor(public payload: Company) {}
}

export class UpdateCompanyWithFormDataActionSuccess implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.UPDATE_COMPANY_WITH_FORM_DATA_SUCCESS;
  constructor(public payload: Company) {}
}

export class UpdateCompanyWithFormDataActionError implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.UPDATE_COMPANY_WITH_FORM_DATA_ERROR;
  constructor(public payload: string) {}
}

// detele a company
export class DeleteCompany implements Action{
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY;
  constructor(public payload: Company){}
}

export class DeleteCompanySuccess implements Action{
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY_SUCCESS;
  constructor(public payload: Company){}
}

export class DeleteCompanyError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY_ERROR;
  constructor(public payload: string){}
}

export type CompanyActionUnion =
  | GetAllCompaniesAction
  | GetAllCompaniesActionSuccess
  | GetAllCompaniesActionError
  | CreateFormToUpdateCompanyAction
  | CreateFormToUpdateCompanyActionSuccess
  | CreateFormToUpdateCompanyActionError
  | UpdateCompanyWithFormDataAction
  | UpdateCompanyWithFormDataActionSuccess
  | UpdateCompanyWithFormDataActionError;
