import { Project } from './../../shared/models/project/project.model';
import { ProjectActionTypes } from './project.action.types';
import { ProjectActionUnion, GetAllProjectsActionSuccess, GetAllProjectsActionError } from './projects.actions';
import { Observable, mergeMap, map, catchError, of } from 'rxjs';
import { Actions, createEffect, ofType } from '@ngrx/effects';
import { ProjectsService } from './../../shared/services/projects.service';
import { Injectable } from '@angular/core';

@Injectable()
export class ProjectGet {
  constructor(
    private projectsService: ProjectsService,
    private projectActions: Actions
  ) {}

  getAllProjectsEffect: Observable<ProjectActionUnion> = createEffect(
    () => this.projectActions.pipe(
      ofType(ProjectActionTypes.GET_ALL_PROJECTS),
      mergeMap((action: ProjectActionUnion)=>{
        return this.projectsService.getAllProjects().pipe(
          map( (projects: Project[] )=> new GetAllProjectsActionSuccess(projects)),
          catchError( err => of(new GetAllProjectsActionError(err.message)))
        );
      })
    )
  );
}
