import { ReactiveFormsModule } from '@angular/forms';
import { TableModule } from 'primeng/table';
import { ButtonModule } from 'primeng/button';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { CompaniesManagerRoutingModule } from './companies-manager-routing.module';
import { CompaniesCreateComponent } from './companies-management/companies-create/companies-create.component';
import { CompanyNavBarComponent } from './companies-management/company-nav-bar/company-nav-bar.component';
import { CompaniesManagementComponent } from './companies-management/companies-management.component';
import { CompaniesListComponent } from './companies-management/companies-list/companies-list.component';
import { CompanyUpdateComponent } from './companies-management/company-update/company-update.component';


@NgModule({
  declarations: [
    CompaniesCreateComponent,
    CompanyNavBarComponent,
    CompaniesManagementComponent,
    CompaniesListComponent,
    CompanyUpdateComponent
  ],
  imports: [
    CommonModule,
    CompaniesManagerRoutingModule,
    ButtonModule,
    TableModule,
    ReactiveFormsModule
  ]
})
export class CompaniesManagerModule { }
